###################### Filebeat Configuration #########################
# You can find the full configuration reference here:
# https://www.elastic.co/guide/en/beats/filebeat/index.html
###########################################################################


{% if monitoring.filebeat.inputs.docker is defined and monitoring.filebeat.modules is defined %}
filebeat.autodiscover:
  providers:
    - type: docker
      templates:
{% for mod in monitoring.filebeat.modules %}
        - condition:
            contains:
              docker.container.image: {{ mod }}
            config:
            - type: docker
              containers.ids:
              - "${data.docker.container.id}"
            - module: {{ mod }}
              log:
                input:
                  type: docker
                  containers.ids:
                  - "${data.docker.container.id}"
{% endfor %}
{% endif %}
#=========================== Filebeat inputs =============================

# NOTE: Filebeat changed "prospectors" to "inputs" in version 6.3. On macOS, Homebrew is still using 6.2.4.
{% if ansible_os_family == "Darwin" %}
filebeat.prospectors:
{% else %}
filebeat.inputs:
{% endif %}
{% if monitoring.filebeat.inputs is defined and 'log' in monitoring.filebeat.inputs %}
#------------------------------ Log input --------------------------------
- type: log
  enabled: true
  # Paths that should be crawled and fetched. Glob based paths.
  paths:
{% for fd in monitoring.filebeat.inputs.log.paths %}
       - {{ fd }}
{% endfor %}
{% if monitoring.filebeat.inputs.log.exclude_lines is defined %}
  exclude_lines: [
    '{{ monitoring.filebeat.inputs.log.exclude_lines  | join("', '") }}'
  ]
{% endif %}
  exclude_files: [".gz$"]
  scan_frequency: 5s
  backoff: 1s
  max_backoff: 20s
  # Tell it to join lines.
{% if 'multiline' in monitoring.filebeat.inputs.log and monitoring.filebeat.inputs.log.multiline.pattern is defined %}
  multiline:
    match: after
    negate: true
    pattern: {{ monitoring.filebeat.inputs.log.multiline }}
    # pattern: '!^[[:space:]]+x'
{% endif %}
{% endif %}

{% if monitoring.filebeat.inputs.docker is defined %}
#------------------------------ Docker input --------------------------------
- type: docker

  # This is the default location so probably not needed.
  path: "/var/lib/docker/containers"

{% if 'multiline' in monitoring.filebeat.inputs.docker and monitoring.filebeat.inputs.docker.multiline.pattern is defined %}
  # Tell it to join lines.
  multiline:
    match: after
    negate: true
    pattern: {{ monitoring.filebeat.inputs.docker.multiline.pattern }}
    # pattern: '!^[[:space:]]+x'
{% endif %}

  # Watch all containers
  containers.ids :
    - "*"

{% if monitoring.filebeat.inputs.docker.exclude_lines is defined %}
  exclude_lines: [
    '{{ monitoring.filebeat.inputs.docker.exclude_lines  | join("', '") }}'
  ]
{% endif %}
  # Combine partial lines flagged by `json-file` format
  combine_partials: true

  processors:
    - add_docker_metadata: ~
    - add_locale.format: offset

  # Dont flood us with json parsing errors:
  ignore_decoding_error: true
{% endif %}

{% if monitoring.filebeat.modules is defined %}
#============================= Filebeat modules ===============================

filebeat.config.modules:
  # Glob pattern for configuration loading
{% if ansible_os_family == "Darwin" %}
  # DISABLE MODULES ON MACOS FOR NOW
  enabled: false
  path: /usr/local/var/homebrew/linked/filebeat/modules.d/*.yml
{% else %}
  enabled: true
  path: /etc/filebeat/modules.d/*.yml
{% endif %}

  # Set to true to enable config reloading
  reload.enabled: false

  # Period on which files under path should be checked for changes
  #reload.period: 10s

{% endif %}
#================================ General =====================================
# Internal queue configuration for buffering events to be published.
queue:
  mem:
    # Max number of events the queue can buffer.
    events: 4096
    flush.min_events: 2048
    flush.timeout: 1s

# Sets the maximum number of CPUs that can be executing simultaneously. The
# default is the number of logical CPUs available in the system.
max_procs: 4

name: filebeat
{##}
{## The name of the shipper that publishes the network data.#}
{#{% if ansible_os_family == "Darwin" %}#}
{#name: build_ios#}
{#{% elif env is defined and app_name is defined and service_name is defined %}#}
{#name: {{ env }}-{{ app_name }}-{{ service_name }}#}
{#{% elif env is defined and app_name is defined %}#}
{#name: {{ env }}-{{ app_name }}#}
{#{% endif %}#}
{##}
{##}
{## Optional fields that you can specify to add additional info#}
{#fields:#}
{#  env: {{ env }}#}
{#  os: {{ os }}#}
{#  app: {{ app_name }}#}
{#{% if jenkins_instance is defined %}#}
{#  jenkins_instance: {{ jenkins_instance   }}#}
{#{% endif %}#}
{#{% if tool_version is defined %}#}
{#  tool_version: {{ tool_version }}#}
{#{% endif %}#}
{##}

#================================ Outputs =====================================
{##}
{##----------------------------- Redis output --------------------------------#}
{#output.redis:#}
{#  enabled: true#}
{#  hosts: ["{{ urls.redis }}"]#}
{#  key: "{{ env }}-filebeat_redis" # removed templating#}
{#  db: 10#}
{#  datatype: list#}
{#  # The Redis connection timeout in seconds. The default is 5 seconds.#}
{#  timeout: 10s#}

output.elasticsearch:
  hosts: ["{{  urls.elasticsearch }}"]
  index: "{{ inventory_hostname }}-%{+YYYY.MM.dd}"
#  username: {{ elk.system_users.beats.username }}
#  password: {{ elk.system_users.beats.password }}


#============================== Dashboards =====================================
# THIS DOES NOT NEED TO BE RUN > ONCE..... THE DASHBOARD NAMES ARE GENERIC

setup.dashboards.enabled: true
setup.dashboards.index: "{{ inventory_hostname }}-*"
setup.template.name: "{{ inventory_hostname }}"
setup.template.pattern: "{{ inventory_hostname }}-*"
# Starting with Beats version 6.0.0, the dashboards are loaded via the Kibana API.
# This requires a Kibana endpoint configuration.
setup.kibana:
  host: {{ urls.kibana }}
#  username: {{ elk.system_users.beats.username }}
#  password: {{ elk.system_users.beats.password }}

#================================ Logging =====================================

# Sets log level. The default log level is info.
logging:
  # Available log levels are: critical, error, warning, info, debug
  level: info
  to_syslog: false
  to_files: true
  files:
    path: /var/log/filebeat
    name: filebeat.log
    rotateeverybytes: 10485760 # = 10MB
    keepfiles: 5
  # At debug level, you can selectively enable logging only for some components.
  # To enable all selectors use ["*"]. Examples of other selectors are "beat",
  # "publish", "service".
  # Other available selectors are beat, publish, service
  selectors: [ "beat", "publish", "service"]
